import { ChangeDetectorRef, EventEmitter } from "@angular/core";
import { MatLegacyDialogRef } from "@angular/material/legacy-dialog";
import { AxiosApiClient, CompoundWidgetDto } from "@smallstack/axios-api-client";
import { FrontendSchemaService } from "@smallstack/common-components";
import { FormComponent } from "@smallstack/form-core-components";
import { SmallstackTypeSchema } from "@smallstack/typesystem";
import { CompoundWidgetStore, WidgetTreeComponent } from "@smallstack/widget-core";
import { FrontendTypeRegistry } from "../../services/frontend-type.registry";
import * as i0 from "@angular/core";
export declare class TypeEditorComponent {
    #private;
    private typeRegistry;
    private axiosApiClient;
    private compoundWidgetStore;
    private schemaService;
    private cdr;
    form: FormComponent;
    protected widgetTreeComponent: WidgetTreeComponent;
    set type(type: string);
    model: any;
    schemaOverride: SmallstackTypeSchema;
    dialogRef: MatLegacyDialogRef<any>;
    readonly modelChange: EventEmitter<any>;
    protected isLoading: boolean;
    protected schema: SmallstackTypeSchema;
    protected compoundWidget: CompoundWidgetDto;
    protected showFallbackForm: boolean;
    constructor(typeRegistry: FrontendTypeRegistry, axiosApiClient: AxiosApiClient, compoundWidgetStore: CompoundWidgetStore, schemaService: FrontendSchemaService, cdr: ChangeDetectorRef);
    validate(): Promise<boolean>;
    validateAndSave(): Promise<any>;
    static ɵfac: i0.ɵɵFactoryDeclaration<TypeEditorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TypeEditorComponent, "smallstack-type-editor", never, { "type": { "alias": "type"; "required": false; }; "model": { "alias": "model"; "required": false; }; "schemaOverride": { "alias": "schemaOverride"; "required": false; }; "dialogRef": { "alias": "dialogRef"; "required": false; }; }, { "modelChange": "modelChange"; }, never, never, true, never>;
}
